import { calculateDirection } from './calculateDirection';

describe('calculateDirection', () => {
  it('Корректно обрабатывает невозможные кейсы (левая координата больше правой)', () => {
    const firstObject = {
      left: 0,
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 10,
      right: 0,
      top: 0,
      bottom: 10,
    };

    expect(calculateDirection(firstObject, secondObject)).toBeNull();
  });

  it('Корректно обрабатывает неверный формат данных', () => {
    const firstObject = {
      left: 'wrong',
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 0,
      right: 10,
      top: 0,
      bottom: 10,
    };

    expect(calculateDirection(firstObject, secondObject)).toBeNull();
  });

  it('Возвращает корректные множители для кейса с отсутствием коллизии', () => {
    const firstObject = {
      left: 0,
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 30,
      right: 40,
      top: 30,
      bottom: 40,
    };

    expect(calculateDirection(firstObject, secondObject)).toEqual([1, 1]);
  });

  it('Возвращает корректные множители для коллизии по оси Y', () => {
    const firstObject = {
      left: 0,
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 5,
      right: 20,
      top: 15,
      bottom: 25,
    };

    expect(calculateDirection(firstObject, secondObject)).toEqual([1, -1]);
  });

  it('Возвращает корректные множители для коллизии по оси X', () => {
    const firstObject = {
      left: 0,
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 15,
      right: 20,
      top: 5,
      bottom: 25,
    };

    expect(calculateDirection(firstObject, secondObject)).toEqual([-1, 1]);
  });

  it('Возвращает корректные множители для коллизии по осям X и Y', () => {
    const firstObject = {
      left: 0,
      right: 20,
      top: 0,
      bottom: 20,
    };

    const secondObject = {
      left: 15,
      right: 25,
      top: 15,
      bottom: 25,
    };

    expect(calculateDirection(firstObject, secondObject)).toEqual([-1, -1]);
  });
});
